<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';
require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';
//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//dynemic db
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';
$postdata = json_decode(file_get_contents("php://input"), true);
checkIfNoPhpContentsReceive();
if (
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$branch_id = $jwt_validate->data->branch_id;
$institution_id = $jwt_validate->data->institution_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,["principal"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific, $version, $updated_time, $userid, $institution_id);

function fetchStudentRegistration($conn_rjllearning, $conn_rjllearning_specific, $institution_id, $branch_id, $search_string, $limit, $offset)
{

    $sql_count = "SELECT COUNT(id) AS total_rows FROM student_registration WHERE  institution_id = ? AND status = ?";
    $array_params = [$institution_id,1];
    if ($search_string != null) {
        $sql_count .= " AND (reg_no LIKE ? OR name LIKE ? OR mobile LIKE ? OR email LIKE ?)   ";
        $array_params[] = '%' . $search_string . '%';
        $array_params[] = '%' . $search_string . '%';
        $array_params[] = '%' . $search_string . '%';
        $array_params[] = '%' . $search_string . '%';
    }
    if ($branch_id == 'all') {
        $sql_count .= "";
    } else if ($branch_id !=  null  && $branch_id != 'all') {
        $sql_count .= " AND branch_id = ? ";
        $array_params[] = $branch_id;
    }
    $validate_student = $conn_rjllearning_specific->prepare($sql_count);
    $validate_student->execute($array_params);

    $result_total = $validate_student->fetchAll();
    $totalrows = $result_total[0]['total_rows'];

    if ($limit == 'all') {

        $sql = "SELECT * FROM  student_registration WHERE institution_id = ? and status=?  ORDER BY id DESC";
        $array_params = [$institution_id,1];
        if ($search_string != null) {
            $sql .= " AND (reg_no LIKE ? OR name LIKE ? OR mobile LIKE ? OR email LIKE ?)   ";
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
        }
        if ($branch_id == 'all') {
            $sql .= "";
        } else if ($branch_id !=  null  && $branch_id != 'all') {
            $sql .= " AND branch_id = ? ";
            $array_params[] = $branch_id;
        }
    } else {
        $sql = "SELECT * FROM  student_registration WHERE institution_id = ? and status=? ";
        $array_params = [$institution_id,1];
        if ($search_string != null) {
            $sql .= " AND (reg_no LIKE ? OR name LIKE ? OR mobile LIKE ? OR email LIKE ?)   ";
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
        }
        if ($branch_id == 'all') {
            $sql .= "";
        } else if ($branch_id !=  null  && $branch_id != 'all') {
            $sql .= " AND branch_id = ? ";
            $array_params[] = $branch_id;
        }
        $sql .= " order by id desc, date_added desc ";
        $sql .= "LIMIT " . $offset . " ," . $limit . "";
    }
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result = $stmt->fetchAll();
    $data = array();
    foreach ($result as $rows) {
        $class_info = getClass($conn_rjllearning_specific, $institution_id, $rows['for_class']);
        $branch_info = getBranchInfo($conn_rjllearning_specific, $institution_id, $rows['branch_id']);
        $current_info = getClass($conn_rjllearning_specific, $institution_id, $rows['current_class']);

        $data[] = array(
            'reg_id' => $rows['id'], 'branch_id' => $branch_info, 'name' => $rows['name'], 'reg_no' => $rows['reg_no'], 'fathername' => $rows['fathername'],
            'mothername' => $rows['mothername'], 'mobile' => $rows['mobile'], 'email' => $rows['email'], 'address_line_1' => $rows['address_line_1'], 'city' => $rows['city'], 'pincode' => $rows['pincode'], 'dob' => $rows['dob'], 'gender' => $rows['gender'],
            'reg_fees' => $rows['reg_fees'], 'paid_through' => $rows['paid_through'], 'refrence_number' => $rows['refrence_number'], 'for_class' => $class_info, 'last_school' => $rows['last_school'], 'current_class' => $current_info
        );
    }
   if (count($result) < 50) {
        return array('total_rows' => $totalrows, 'registration_info' => $data, 'maxreach' => 1);
    } else {
        return array('total_rows' => $totalrows, 'registration_info' => $data, 'maxreach' => 0);
    }
}


if ($postdata['function_type'] == "fetch_student_registration") {

    // $branch_id = trim($postdata['branch_id']);

    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }
    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;
    $limit = $postdata['limit'];
    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
    } else {
        $offset = null;
    }
    $success['data'] = fetchStudentRegistration($conn_rjllearning, $conn_rjllearning_specific, $institution_id, $branch_id, $search_string, $limit, $offset);
    successreturn($success);
}
